--[[
	Copyright (C) Udorn (Blackhand)
--]]

petbm = petbm or {}
   
petbm.PetStable = petbm.PetBattleMaster:NewModule("PetStable", "AceEvent-3.0")
local L = petbm.Locale.GetInstance()
local LibPetJournal = LibStub("LibPetJournal-2.0")
local log = petbm.Debug:new("PetStable")

local IS_WILD = false -- WTF why is it false ?!

local function PetsUpdated(self)
	log:Debug("PetsUpdated")
	
	local pets = wipe(self.pets)
	local knownByName = wipe(self.knownByName)
	local ownedByName = wipe(self.ownedByName)
	local speciesIds = wipe(self.speciesIds)
	
	for i,petId in LibPetJournal:IteratePetIDs() do
        local speciesId, customName, level, xp, maxXp, displayID, isFavorite, name, icon,
            petType, creatureId = C_PetJournal.GetPetInfoByPetID(petId)
        local quality = select(5, C_PetJournal.GetPetStats(petId)) or 1
       	tinsert(pets, {petId = petId, speciesId = speciesId, quality = quality, creatureId = creatureId, level = level, name = name})
       	ownedByName[name] = true
    end
    
    local numPets = 0
    for i,speciesId in LibPetJournal:IterateSpeciesIDs() do
    	speciesIds[speciesId] = true
    	local name = C_PetJournal.GetPetInfoBySpeciesID(speciesId)
    	knownByName[name] = true 
    	numPets = numPets + 1
	end
	
	log:Debug("PetsUpdated exit with [%s] pets and [%s] speciesIds", #pets, numPets)
	self:SendMessage("PETS_UPDATED")
end

local function GetOwnPets(self)
	return ipairs(self.pets)
end

local function GetAllPets(self)
	return ipairs(self.allPets)
end

local function IsSpeciesIdKnown(self, speciesId)
	return self.speciesIds[speciesId]
end

local function IsKnownByName(self, name)
	return self.knownByName[name]
end

local function IsOwnedByName(self, name)
	return self.ownedByName[name]
end

local function OnInitialize(self)
	self.pets = {}
	self.knownByName = {}
	self.ownedByName = {}
	self.rarityCache = {}
	self.petTypes = {}
	self.petSources = {}
	self.flags = {}
	self.speciesIds = {}
	LibPetJournal.RegisterCallback(petbm.PetStable, "PetListUpdated", "PetsUpdated")
end

petbm.PetStable.OnInitialize = OnInitialize
petbm.PetStable.OnEnable = OnEnable
petbm.PetStable.GetOwnPets = GetOwnPets
petbm.PetStable.PetsUpdated = PetsUpdated
petbm.PetStable.IsSpeciesIdKnown = IsSpeciesIdKnown
petbm.PetStable.IsKnownByName = IsKnownByName
petbm.PetStable.IsOwnedByName = IsOwnedByName